:- modeh(1,legal_move(+player,+board,+board))?

:- modeb(*,row(-row))?
:- modeb(*,col(-col))?
:- modeb(*,frame(+row,+col,+board,+board))?
:- modeb(*,frame(+row,+col,+board,-board))?
:- modeb(*,owns(+player,-piece))?
:- modeb(*,owns_piece(-poutcome,-piece))?
:- modeb(*,at(+row,+col,+board,+piece))?
:- modeb(*,at(+row,+col,+board,-piece))?
:- modeb(*,at(+row,+col,+board,#piece))?

prune(_,Body) :- in(frame(A,B,C,D),Body), C==D.

:- set(posonly)?
:- set(noise,0)?
:- set(c,10)?
:- set(h,200)?
:- set(n,500)?
:- set(r,2000)?
:- set(i,100)?
:- set(nodes,3000)?
:- set(verbose,0)?

player(player_x).
player(player_o).
piece(x).
piece(o).
piece(none).
poutcome(x_wins).
poutcome(o_wins).
poutcome(not_over_yet).
owns(player_x,x).
owns(player_o,o).
owns_outcome(player_x,x_wins).
owns_outcome(player_o,o_wins).
owns_piece(x_wins,x).
owns_piece(o_wins,o).
opponent(player_x,player_o).
opponent(player_o,player_x).

row_to_int(r0,0).
row_to_int(r1,1).
row_to_int(r2,2).
col_to_int(c0,0).
col_to_int(c1,1).
col_to_int(c2,2).

ref(0,[H|T],H).
ref(I,[H|T],H2) :- dec(I,J), ref(J,T,H2).

inc(X,Y) :- Y is X + 1.
dec(X,Y) :- Y is X - 1.

replace(0,H1,[H2|T],[H1|T]).
replace(I,H1,[H2|T1],[H2|T2]) :- dec(I,J), replace(J,H1,T1,T2).

at(ROW,COLUMN,BOARD,PIECE) :- row_to_int(ROW,RI),
	col_to_int(COLUMN,CI),
	ref(RI,BOARD,L),ref(CI,L,PIECE).

frame(RROW,CCOLUMN,BOARD1,BOARD2) :-
	row(RROW),
	col(CCOLUMN),
	row_to_int(RROW,ROW),
	col_to_int(CCOLUMN,COLUMN),
	board(BOARD1),
	board(BOARD2),
	ref(ROW,BOARD1,L1),
	replace(COLUMN,ignore,L1,L2),
	replace(ROW,L2,BOARD1,BOARD3),
	ref(ROW,BOARD2,L3),
	replace(COLUMN,ignore,L3,L4),
	replace(ROW,L4,BOARD2,BOARD4),
	BOARD3 == BOARD4.

row(r0).
col(c0).
row(r1).
col(c1).
row(r2).
col(c2).

board([[none,none,none],[none,none,none],[none,none,none]]).
outcome([[none,none,none],[none,none,none],[none,none,none]],not_over_yet).
legal_move(player_x,[[none,none,none],[none,none,none],[none,none,none]],[[none,none,none],[none,none,none],[none,none,x]]).
board([[none,none,none],[none,none,none],[none,none,x]]).
outcome([[none,none,none],[none,none,none],[none,none,x]],not_over_yet).
legal_move(player_o,[[none,none,none],[none,none,none],[none,none,x]],[[none,none,none],[o,none,none],[none,none,x]]).
board([[none,none,none],[o,none,none],[none,none,x]]).
outcome([[none,none,none],[o,none,none],[none,none,x]],not_over_yet).
legal_move(player_x,[[none,none,none],[o,none,none],[none,none,x]],[[none,none,none],[o,x,none],[none,none,x]]).
board([[none,none,none],[o,x,none],[none,none,x]]).
outcome([[none,none,none],[o,x,none],[none,none,x]],not_over_yet).
legal_move(player_o,[[none,none,none],[o,x,none],[none,none,x]],[[none,o,none],[o,x,none],[none,none,x]]).
board([[none,o,none],[o,x,none],[none,none,x]]).
outcome([[none,o,none],[o,x,none],[none,none,x]],not_over_yet).
legal_move(player_x,[[none,o,none],[o,x,none],[none,none,x]],[[none,o,x],[o,x,none],[none,none,x]]).
board([[none,o,x],[o,x,none],[none,none,x]]).
outcome([[none,o,x],[o,x,none],[none,none,x]],not_over_yet).
legal_move(player_o,[[none,o,x],[o,x,none],[none,none,x]],[[none,o,x],[o,x,none],[none,o,x]]).
board([[none,o,x],[o,x,none],[none,o,x]]).
outcome([[none,o,x],[o,x,none],[none,o,x]],not_over_yet).
legal_move(player_x,[[none,o,x],[o,x,none],[none,o,x]],[[none,o,x],[o,x,x],[none,o,x]]).
board([[none,o,x],[o,x,x],[none,o,x]]).
outcome([[none,o,x],[o,x,x],[none,o,x]],x_wins).
